#ifndef __DISCRETE_IO_H__
#define __DISCRETE_IO_H__


enum {
   TOGGLE_SWITCH_0 = 0,
   TOGGLE_SWITCH_1,
   ITEMS_MAX
};


#define BITS_MAXIMUM   64 /*ITEMS_MAX*/
typedef int (*FPVOID)(void *param);

typedef struct {
int counter;
char signal;
int  max;
char evcode;
char flag;
char mode;
FPVOID get_bit;
LPC_GPIO_TypeDef *port;
int pin;
} BITS_DESCRIPTION;

extern FIFO inputs_ev;

#define FLAG_INVERTED   (1<<0)
#define FLAG_ENABLED    (1<<1)


enum {
  PUSH_BUTTON = 0,
  TOGGLE_SWITCH,
  ROTARY_SWITCH_POLE,
  ENCODER_A,
  ENCODER_B
};


#define input_init(x,y,z,m)   do {\
bits[x].counter = 0;\
bits[x].signal = 0;\
bits[x].max = 50;\
bits[x].flag = (FLAG_ENABLED /*| FLAG_INVERTED*/);\
bits[x].port = y;\
bits[x].pin = z;\
bits[x].mode = m;\
bits[x].get_bit = NULL;} while(0)


#define input_init_fast(x,y,z,m)   do {\
bits[x].counter = 0;\
bits[x].signal = 0;\
bits[x].max = 2;\
bits[x].flag = (FLAG_ENABLED/* | FLAG_INVERTED*/);\
bits[x].port = y;\
bits[x].pin = z;\
bits[x].mode = m;\
bits[x].get_bit = NULL;} while(0)


void bits_init(void);
void discrete_task( void);

void led_control(int led, int state);
void leds_init(void);


#endif

