#include "includes.h"


void gpio_init(void)
{

   LPC_SYSCON->SYSAHBCLKCTRL |= SYSCON_AHBPeriph_GPIO & SYSCON_AHBPeriph_BITMASK;

   LPC_GPIO0->DIR = \
		   LPC_GPIO1->DIR = \
		   LPC_GPIO2->DIR = \
		   LPC_GPIO3->DIR = 0;

   // Reset all GPIO pins to default primary function
           LPC_IOCON->PIO2_6 = \
		   LPC_IOCON->PIO2_0 = \
		   LPC_IOCON->RESET_PIO0_0 = \
		   LPC_IOCON->PIO0_1 = \
		   LPC_IOCON->PIO1_8 = \
		   LPC_IOCON->PIO0_2 = \
		   LPC_IOCON->PIO2_7 = \
		   LPC_IOCON->PIO2_8 = \
		   LPC_IOCON->PIO2_1 = \
		   LPC_IOCON->PIO0_3 = \
		   LPC_IOCON->PIO2_4 = \
		   LPC_IOCON->PIO2_5 = \
		   LPC_IOCON->PIO0_6 = \
		   LPC_IOCON->PIO2_9 = \
		   LPC_IOCON->PIO2_10 = \
		   LPC_IOCON->PIO2_2 = \
		   LPC_IOCON->PIO0_8 = \
		   LPC_IOCON->JTAG_TCK_PIO0_10 = \
		   LPC_IOCON->PIO2_11 = \
		   LPC_IOCON->PIO3_0 = \
		   LPC_IOCON->PIO2_3 = \
		   LPC_IOCON->PIO1_5 = \
		   LPC_IOCON->PIO1_6 = \
		   LPC_IOCON->PIO1_9 = \
		   LPC_IOCON->PIO3_1 = \
		   LPC_IOCON->PIO3_2 = \
		   LPC_IOCON->PIO3_3 = 0x50;

   LPC_IOCON->PIO1_10 = \
		   LPC_IOCON->ARM_SWDIO_PIO1_3 = \
		   LPC_IOCON->PIO1_4 = \
		   LPC_IOCON->PIO1_11 = 0xD0;

   LPC_IOCON->JTAG_TMS_PIO1_0 = 0x81;
   LPC_IOCON->JTAG_TDO_PIO1_1 = 0x81;
   LPC_IOCON->JTAG_nTRST_PIO1_2 = 0x81;
   LPC_IOCON->JTAG_TDI_PIO0_11 = 0x81;
   LPC_IOCON->PIO1_10 = 0x80;

   LPC_IOCON->PIO0_4 = \
		   LPC_IOCON->PIO0_5 = \
		   LPC_IOCON->PIO0_7 = 0x00;

   LPC_IOCON->SCKLOC = 0x00;

   inputs64_init();


#if 0
  // Set to inputs
  LPC_GPIO0->DIR = \
  LPC_GPIO1->DIR = \
  LPC_GPIO2->DIR = \
  LPC_GPIO3->DIR = 0;

  // Reset all GPIO pins to default primary function
  LPC_IOCON->PIO2_6 = \
  LPC_IOCON->PIO2_0 = \
  LPC_IOCON->RESET_PIO0_0 = \
  LPC_IOCON->PIO0_1 = \
  LPC_IOCON->PIO0_2 = \
  LPC_IOCON->PIO1_8 = \
  LPC_IOCON->PIO2_7 = \
  LPC_IOCON->PIO2_8 = \
  LPC_IOCON->PIO2_1 = \
  LPC_IOCON->PIO0_3 = \
  LPC_IOCON->PIO2_4 = \
  LPC_IOCON->PIO2_5 = \
  LPC_IOCON->PIO0_6 = \
  LPC_IOCON->PIO2_9 = \
  LPC_IOCON->PIO2_10 = \
  LPC_IOCON->PIO2_2 = \
  LPC_IOCON->PIO0_8 = \
  LPC_IOCON->JTAG_TCK_PIO0_10 = \
  LPC_IOCON->PIO2_11 = \
  LPC_IOCON->PIO3_0 = \
  LPC_IOCON->PIO2_3 = \
  LPC_IOCON->PIO1_5 = \
  LPC_IOCON->PIO1_6 = \
  LPC_IOCON->PIO1_9 = \
  LPC_IOCON->PIO3_1 = \
  LPC_IOCON->PIO3_2 = \
  LPC_IOCON->PIO3_3 = 0x50;

  LPC_IOCON->ARM_SWDIO_PIO1_3 = \
  LPC_IOCON->PIO1_4 = 0xD0;
  LPC_IOCON->PIO1_11 = 0x90;

  LPC_IOCON->JTAG_TMS_PIO1_0 = 0x91;
  LPC_IOCON->JTAG_TDO_PIO1_1 = 0x91;
  LPC_IOCON->JTAG_nTRST_PIO1_2 = 0x91;
  LPC_IOCON->JTAG_TDI_PIO0_11 = 0x91;
  LPC_IOCON->PIO1_10 = 0x90;

  LPC_IOCON->PIO0_4 = \
  LPC_IOCON->PIO0_5 = \
  LPC_IOCON->SCKLOC = 0x00;


  LPC_IOCON->PIO0_7 = 0x10;
#endif
}


