/*****************************************************************************
 *   timer16.h:  Header file for NXP LPC13xx Family Microprocessors
 *
 *   Copyright(C) 2008, NXP Semiconductor
 *   All rights reserved.
 *
 *   History
 *   2008.08.20  ver 1.00    Prelimnary version, first Release
 *
 *   $Revision: 24 $
 ******************************************************************************/

/*
$Id: timer16.h 24 2011-07-11 15:12:25Z akostyuk $
$HeadURL: svn://mysvn.dyndns-at-work.com/pbf/antiskim_arm/firmware/applications/antiskimmer_cortex_m3/timer16.h $
*/

#ifndef __TIMER16_H
#define __TIMER16_H

#define TIME_INTERVAL	(12000000UL/100 - 1)
/* depending on the SystemFrequency and SystemAHBFrequency setting,
if SystemFrequency = 60Mhz, SystemAHBFrequency = 1/4 SystemAHBFrequency,
10mSec = 150.000-1 counts */

void delayMs(uint8_t timer_num, uint32_t delayInMs);
void CT16B0_IRQHandler(void);
void CT16B1_IRQHandler(void);
void enable_timer16(uint8_t timer_num);
void disable_timer16(uint8_t timer_num);
void reset_timer16(uint8_t timer_num);
void init_timer16(uint8_t timer_num, uint32_t timerInterval);


extern int pulse_period;
extern int pulse_width;


void restart_timer_100ms(void);
int is_timer_100ms_zero(void);


#endif /* end __TIMER16_H */
/*****************************************************************************
**                            End Of File
******************************************************************************/
